<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">系统管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/withdrawalRecord">营收用户提现审核</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form
      ref="queryForm"
      :model="queryModel"
      inline
      class="demo-form-inline"
    >
      <el-form-item label="关联的公司车队" prop="companyId">
        <el-select-tree
          :props="props"
          :options="companyResult"
          v-model="queryModel.companyId"
          size="mini"
          width="200px"
        ></el-select-tree>
      </el-form-item>
      <el-form-item label="商户名称" prop="name">
        <el-input type="text" size="mini" v-model="queryModel.name"></el-input>
      </el-form-item>
      <!-- <el-form-item label="申请时间" prop="applyTime">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.applyTime"
        ></el-input>
      </el-form-item> -->
      <el-form-item label="提现编号" prop="withdrawalNo">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.withdrawalNo"
        ></el-input>
      </el-form-item>
      <el-form-item label="审批状态" prop="status">
        <el-select
          v-model="queryModel.status"
          size="mini"
          placeholder="请选择"
          style="width: 100px"
        >
          <el-option label="全部" value=""> </el-option>
          <el-option label="申请中" value="0"> </el-option>
          <el-option label="同意" value="1"> </el-option>
          <el-option label="拒绝" value="2"> </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
          >查询</el-button
        >&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
          >重置</el-button
        >&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group"> </el-row>
    <el-table
      :data="tableData"
      style="min-height: 400px"
      v-loading="loading"
      stripe
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column
        type="index"
        label="序号"
        :index="indexMethod"
        width="50"
      ></el-table-column>
      <el-table-column
        prop="accountInfo.companyName"
        label="所属公司"
        width="150"
      ></el-table-column>
      <el-table-column
        prop="accountInfo.name"
        label="提现人员名称"
        width="150"
      ></el-table-column>
      <el-table-column
        prop="accountInfo.bankName"
        label="银行名称"
        show-overflow-tooltip
        width="150"
      ></el-table-column>
      <el-table-column
        prop="accountInfo.bankNumber"
        label="银行卡账号"
        show-overflow-tooltip
        width="200"
      ></el-table-column>
      <el-table-column
        prop="withdrawalNo"
        label="提现编号"
        width="250"
        show-overflow-tooltip
      ></el-table-column>
      <el-table-column
        prop="applyWithdrawalAmount"
        label="申请提现金额"
        width="150"
      ></el-table-column>
      <el-table-column
        prop="applyTime"
        label="申请时间"
        width="180"
      ></el-table-column>
      <el-table-column prop="status" label="状态" width="150">
        <template slot-scope="{ row }">
          <span v-if="row.status == 0">申请中</span>
          <span v-else-if="row.status == 1">同意</span>
          <span v-else-if="row.status == 2">拒绝</span>
        </template>
      </el-table-column>
      <el-table-column
        prop="examineTime"
        label="审核时间"
        width="180"
      ></el-table-column>
      <el-table-column prop="remark" label="备注" width="180"></el-table-column>
      <el-table-column label="操作" fixed="right" width="180">
        <template slot-scope="{ row }">
          <el-row>
            <el-col :span="12">
              <el-link
                v-if="row.status == 0"
                type="primary"
                :underline="false"
                @click="handleApproval(row, '1')"
                >审核通过</el-link
              >
            </el-col>
            <el-col :span="12">
              <el-link
                v-if="row.status == 0"
                type="primary"
                :underline="false"
                @click="handleApproval(row, '2')"
                >审核不通过</el-link
              >
            </el-col>
          </el-row>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <withdrawalRecord-detail
      v-if="showModal"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></withdrawalRecord-detail>
  </div>
</template>
<script>
import Constant from "@/constant";
import WithdrawalRecordDetail from "./withdrawalRecord-detail";
import withdrawalRecordApi from "@/api/merchant/withdrawalRecord";
import companyInfoApi from "@/api/bus/companyInfo";
import SelectTree from "@/components/SelectTree";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style

export default {
  data() {
    var self = this;

    return {
      queryModel: {
        id: "",
        companyId: "",
        name: "",
        phone: "",
        applyTime: "",
        status: "",
        withdrawalNo: "",
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      modalTitle: "",
      businessKey: "",
      companyResult: [],
      treeData: [],
      props: {
        // 配置项（必选）
        value: "id",
        label: "name",
        children: "children",
      },
    };
  },
  created() {
    var self = this;

    companyInfoApi.treeList().then(function (response) {
      var jsonData = response.data;
      if (jsonData.result) {
        self.companyResult = jsonData.data;
      }
    });
  },
  methods: {
    indexMethod(index) {
      return (this.pageIndex - 1) * this.pageSize + (index + 1);
    },
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("id", self.queryModel.id);
      formData.append("merchantId", self.queryModel.merchantId);
      formData.append(
        "applyWithdrawalAmount",
        self.queryModel.applyWithdrawalAmount
      );
      formData.append("name", self.queryModel.name);
      formData.append("status", self.queryModel.status);
      if (self.queryModel.companyId == null) {
        self.queryModel.companyId = "";
      }
      formData.append("companyId", self.queryModel.companyId);
      formData.append("examineBy", self.queryModel.examineBy);
      formData.append("withdrawalNo", self.queryModel.withdrawalNo);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      withdrawalRecordApi
        .pageList(formData)
        .then(function (response) {
          self.loading = false;

          var jsonData = response.data.data;

          self.tableData = jsonData.data;
          self.totalPages = jsonData.totalPages;
          self.totalElements = jsonData.recordsTotal;
        })
        .catch((error) => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(() => {
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order;

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.businessKey = "";
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.businessKey = record.id;
      this.showModal = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          withdrawalRecordApi.remove(record.id).then(function (response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!",
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map((record) => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        withdrawalRecordApi.batchRemove(idList).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!",
            });
          }
        });
      });
    },
    onDetailModalClose(refreshed) {
      //保存成功后回调
      this.showModal = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },
    handleApproval(record, status) {
      var self = this;
      self
        .$confirm("是否确认审核?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          var formData = new FormData();
          formData.append("id", record.id);
          formData.append("status", status);
          withdrawalRecordApi.approval(formData).then(function (response) {
            var jsonData = response.data;

            if (jsonData.result) {
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: jsonData.message,
              });
            } else {
              self.$message({
                showClose: true,
                dangerouslyUseHTMLString: true,
                message: jsonData.message,
              });
            }
          });
        });
    },
  },
  mounted: function () {
    this.changePage(1);
  },
  components: {
    "el-select-tree": SelectTree,
    "withdrawalRecord-detail": WithdrawalRecordDetail,
  },
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  margin-left: 10px;
  text-align: left;
}
</style>